// This file is generated by kconfig_compiler_kf5 from kamosoSettings.kcfg.
// All changes you do to this file will be lost.
#ifndef SETTINGS_H
#define SETTINGS_H

#include <kconfigskeleton.h>
#include <QCoreApplication>
#include <QDebug>

#include <QStandardPaths>

class Settings : public KConfigSkeleton
{
  Q_OBJECT
  public:

    static Settings *self();
    ~Settings();

    /**
      Set Where the photos are saved.
    */
    static
    void setSaveUrl( const QUrl & v )
    {
      if (v != self()->mSaveUrl && !self()->isSaveUrlImmutable()) {
        self()->mSaveUrl = v;
        Q_EMIT self()->saveUrlChanged();
      }
    }

    Q_PROPERTY(QUrl saveUrl READ saveUrl WRITE setSaveUrl NOTIFY saveUrlChanged)
    Q_PROPERTY(bool isSaveUrlImmutable READ isSaveUrlImmutable CONSTANT)
    /**
      Get Where the photos are saved.
    */
    static
    QUrl saveUrl()
    {
      return self()->mSaveUrl;
    }

    /**
      Is Where the photos are saved. Immutable
    */
    static
    bool isSaveUrlImmutable()
    {
      return self()->isImmutable( QStringLiteral( "saveUrl" ) );
    }

    /**
      Set Where the photos are saved.
    */
    static
    void setSaveVideos( const QUrl & v )
    {
      if (v != self()->mSaveVideos && !self()->isSaveVideosImmutable()) {
        self()->mSaveVideos = v;
        Q_EMIT self()->saveVideosChanged();
      }
    }

    Q_PROPERTY(QUrl saveVideos READ saveVideos WRITE setSaveVideos NOTIFY saveVideosChanged)
    Q_PROPERTY(bool isSaveVideosImmutable READ isSaveVideosImmutable CONSTANT)
    /**
      Get Where the photos are saved.
    */
    static
    QUrl saveVideos()
    {
      return self()->mSaveVideos;
    }

    /**
      Is Where the photos are saved. Immutable
    */
    static
    bool isSaveVideosImmutable()
    {
      return self()->isImmutable( QStringLiteral( "saveVideos" ) );
    }

    /**
      Set Points to the last used webcam.
    */
    static
    void setDeviceUdi( const QString & v )
    {
      if (v != self()->mDeviceUdi && !self()->isDeviceUdiImmutable()) {
        self()->mDeviceUdi = v;
        Q_EMIT self()->deviceUdiChanged();
      }
    }

    Q_PROPERTY(QString deviceUdi READ deviceUdi WRITE setDeviceUdi NOTIFY deviceUdiChanged)
    Q_PROPERTY(bool isDeviceUdiImmutable READ isDeviceUdiImmutable CONSTANT)
    /**
      Get Points to the last used webcam.
    */
    static
    QString deviceUdi()
    {
      return self()->mDeviceUdi;
    }

    /**
      Is Points to the last used webcam. Immutable
    */
    static
    bool isDeviceUdiImmutable()
    {
      return self()->isImmutable( QStringLiteral( "deviceUdi" ) );
    }


    enum {
      signalSaveUrlChanged = 0x1,
      signalSaveVideosChanged = 0x2,
      signalDeviceUdiChanged = 0x4
    };

  Q_SIGNALS:
    void saveUrlChanged();

    void saveVideosChanged();

    void deviceUdiChanged();

  private:
    void itemChanged(quint64 flags);

  protected:
    Settings();
    friend class SettingsHelper;


    // General
    QUrl mSaveUrl;
    QUrl mSaveVideos;

    // WebcamSettings
    QString mDeviceUdi;

  private:
};

#endif

